extern crate reqwest;
extern crate select;
extern crate serde_json;
extern crate retry;
extern crate linked_hash_map;
extern crate scryfall;

#[macro_use]
extern crate mopa;

pub mod searchers;

//use std::any::Any;
use mopa::Any;

pub trait Link: Any {
    fn label (&self) -> &str;
    fn url (&self) -> &str;
    fn as_any(&self) -> &Any;
}

mopafy!(Link);

impl Link for Box<Link + 'static> {
    fn label (&self) -> &str {
        (**self).label()
    }

    fn url (&self) -> &str {
        (**self).url()
    }

    fn as_any (&self) -> &Any {
        self
    }
}
